safe-umd-webpack-plugin

Webpack plugin to handle optional dependency safely when using libraryTarget: umd

Downloads in past

Stats

StarsIssuesVersionUpdatedCreatedSize
safe-umd-webpack-plugin
104.0.04 years ago5 years agoMinified + gzip package size for safe-umd-webpack-plugin in KB

Readme

safe-umd-webpack-plugin
Webpack plugin to handle optional dependencies safely when using libraryTarget: umd.

When to use

When using umd as a libraryTarget with config like :
module.exports = {
  entry: './src/index.js',
  output: {
    library: ['my', 'module'],
    libraryTarget: 'umd',
    filename: 'bundle.js'
  },
  externals: {
    'my-ext-module': {
      commonjs: 'my-ext-module',
      commonjs2: 'my-ext-module',
      amd: 'my-ext-module',
      root: ['my', 'ext', 'module']
    }
  }
}; 

You can't use optional dependencies for a root (namespace) because of the generated code like :
root["my"] = root["my"] || {}, root["my"]["module"] = factory(root["my"]["ext"]["module"]);

This plugin replace code above to safely access the namespace with code like :
root["my"] = root["my"] || {}, root["my"]["module"] = factory(root["my"] && root["my"]["ext"] && root["my"]["ext"]["module"]);

How to use

Install

npm install safe-umd-webpack-plugin --save-dev

Config

// webpack.config.js

var SafeUmdPlugin = require('safe-umd-webpack-plugin');

// ...
module.exports = {
  // ...
  plugins: [
    //...
    new SafeUmdPlugin()
  ]
}